using System;


/// @author  Vesa Lappalainen
/// @version 27.10.2012
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class Elaimet
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000);
        Koira musti = new Koira("Musti", 2700);
        miuku.Aantele();  // Aantele(miuku)
        Console.WriteLine(miuku.ToString());
        mirri.Aantele();
        Console.WriteLine(mirri.ToString());
        musti.Aantele();
        Console.WriteLine(musti.ToString());
        
        // List<Kissa> elukat = new List<Kissa>();

    }
}


public class Kissa  // luokka ja oliot ovat luokan esiintymiä, periytyy Object luokasta
{
    private readonly string nimi;
    private readonly double paino;
    
    public Kissa(string nimi, double paino)  // muodostaja, konstruktori
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    override
        public string ToString() // metodi
    {
        return this.nimi + " " + this.paino;
    }
    

    public void Aantele()
    {
        Console.WriteLine("Miaauuu");
    }
}


public class Koira  // luokka ja oliot ovat luokan esiintymiä, periytyy Object luokasta
{
    private readonly string nimi;
    private readonly double paino;
    
    public Koira(string nimi, double paino)  // muodostaja, konstruktori
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    override
        public string ToString() // metodi
    {
        return this.nimi + " " + this.paino;
    }
    

    public void Aantele()
    {
        Console.WriteLine("Hau hau");
    }
}