using System;
using System.Collections.Generic;


/// @author  Vesa Lappalainen
/// @version 27.10.2012
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class ElaimetPerimalla
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000, 30);
        Koira musti = new Koira("Musti", 2700);

        List<Elain> elukat = new List<Elain>();
        elukat.Add(miuku);
        elukat.Add(mirri);
        elukat.Add(musti);
        
        foreach (Elain elain in elukat) // polymorfismi
        {
            elain.Aantele();
            Console.WriteLine(elain);
        }

    }
}


public class Elain  // luokka ja oliot ovat luokan esiintymiä, periytyy Object luokasta
{
    private readonly string nimi;
    private readonly double paino;

    protected Elain(string nimi, double paino)  // muodostaja, konstruktori
    {
        this.nimi = nimi;
        this.paino = paino;
    }

    
    public override string ToString() // metodi
    {
        return this.nimi + " " + this.paino;
    }
    

    public virtual void Aantele()
    {
        Console.WriteLine("????");
    }
}


public class Kissa: Elain  // luokka ja oliot ovat luokan esiintymiä, periytyy Elain luokasta
{
    private int viikset;
    public Kissa(string nimi, double paino, int viikset=20): base(nimi, paino)  // muodostaja, konstruktori
    {
        this.viikset = viikset;
    }

    
    public override void Aantele()
    {
        Console.WriteLine("Miaauuu");
    }

    public override string ToString() // metodi
    {
        return base.ToString() + " " + this.viikset;
    }
    

}


public class Koira: Elain  // luokka ja oliot ovat luokan esiintymiä, periytyy Elain luokasta
{
    public Koira(string nimi, double paino): base(nimi, paino)  // muodostaja, konstruktori
    {
    }

    
    public override void Aantele()
    {
        Console.WriteLine("Hau hau");
    }
}

